import React, { forwardRef, useState, useEffect } from "react";
var BootstrapDragHandle = forwardRef(function BootstrapDragHandle2({ className, title }, dragRef) {
  return /* @__PURE__ */ React.createElement("span", {
    ref: dragRef,
    className,
    title
  }, /* @__PURE__ */ React.createElement("i", {
    className: "bi bi-grip-vertical"
  }));
});
const BootstrapNotToggle = ({
  className,
  handleOnChange,
  title,
  label,
  checked
}) => {
  const [id] = useState(`notToggle-${Math.random()}`);
  return /* @__PURE__ */ React.createElement("div", {
    className: `form-check-inline form-switch ${className}`
  }, /* @__PURE__ */ React.createElement("input", {
    id,
    className: "form-check-input",
    type: "checkbox",
    onChange: (e) => handleOnChange(e.target.checked),
    checked: !!checked
  }), /* @__PURE__ */ React.createElement("label", {
    title,
    htmlFor: id,
    className: "form-check-label"
  }, label));
};
BootstrapNotToggle.displayName = "BootstrapNotToggle";
const BootstrapValueEditor = ({
  fieldData,
  operator,
  value,
  handleOnChange,
  title,
  className,
  type,
  inputType,
  values
}) => {
  var _a;
  useEffect(() => {
    if (inputType === "number" && !["between", "notBetween"].includes(operator) && typeof value === "string" && value.includes(",")) {
      handleOnChange("");
    }
  }, [inputType, operator, value, handleOnChange]);
  if (operator === "null" || operator === "notNull") {
    return null;
  }
  const placeHolderText = (_a = fieldData == null ? void 0 : fieldData.placeholder) != null ? _a : "";
  const inputTypeCoerced = ["between", "notBetween"].includes(operator) ? "text" : inputType || "text";
  switch (type) {
    case "select":
      return /* @__PURE__ */ React.createElement("select", {
        className: `${className} form-select form-select-sm`,
        title,
        onChange: (e) => handleOnChange(e.target.value),
        value
      }, values.map((v) => /* @__PURE__ */ React.createElement("option", {
        key: v.name,
        value: v.name
      }, v.label)));
    case "checkbox":
      return /* @__PURE__ */ React.createElement("input", {
        type: "checkbox",
        className: `form-check-input ${className}`,
        title,
        onChange: (e) => handleOnChange(e.target.checked),
        checked: !!value
      });
    case "radio":
      return /* @__PURE__ */ React.createElement("span", {
        title
      }, values.map((v) => /* @__PURE__ */ React.createElement("div", {
        key: v.name,
        className: "form-check form-check-inline"
      }, /* @__PURE__ */ React.createElement("input", {
        className: "form-check-input",
        type: "radio",
        id: v.name,
        value: v.name,
        checked: value === v.name,
        onChange: (e) => handleOnChange(e.target.value)
      }), /* @__PURE__ */ React.createElement("label", {
        className: "form-check-label",
        htmlFor: v.name
      }, v.label))));
    default:
      return /* @__PURE__ */ React.createElement("input", {
        type: inputTypeCoerced,
        value,
        title,
        className,
        placeholder: placeHolderText,
        onChange: (e) => handleOnChange(e.target.value)
      });
  }
};
BootstrapValueEditor.displayName = "ValueEditor";
export { BootstrapDragHandle, BootstrapNotToggle, BootstrapValueEditor };
